ARCHIVE_KEEPNBACKUPS=30
ARCHIVE_KEEPNDAYS=30
BACKUP_RUNEVERYNTHDAY=1
+BWLIMIT=500KiB
-function upperme {
- echo $(basename $0) | tr '[:lower:]' '[:upper:]'
+_ERROR_ENCOUNTERED=0
+
+function timestamp {
+ date +'[%y-%m-%d|%H:%M:%S]'
+}
+
+function scottyline {
+ echo $(timestamp) $@
}
function scottyinfo {
- echo $(upperme): $@
+ if [ $_ERROR_ENCOUNTERED -eq 0 ]; then
+ scottyline $@
+ else
+ scottyline $@ >&2
+ fi
}
function scottyerror {
- echo $(upperme): $@ >&2
+ scottyline $@ >&2
+ if [ $_ERROR_ENCOUNTERED -eq 0 ]; then
+ _ERROR_ENCOUNTERED=1
+ scottyline "Going into verbose mode after error encounter." >&2
+ fi
}
function ssh255 {
}
function isNthDay {
- if [ $(( ( $(date +%s) / (60*60*24) ) % $BACKUP_RUNEVERYNTHDAY )) -eq 0 ];
+ if [ $(( ( $(date +%s) / (60*60*24) ) % $BACKUP_RUNEVERYNTHDAY )) -eq 0 ];
then
return 0
else
return 1
- fi
+ fi
}
function latestTooOld {
for oldbackup in $(grepbackups); do
tstamp=$(echo $oldbackup | cut -d'-' -f1)
-
- if [ $(( $(date +%s) - $tstamp )) -lt \
- $(( ($BACKUP_RUNEVERYNTHDAY*24+12)*60*60 )) ]
+
+ if [ $(( $(date +%s) - $tstamp )) -lt $(( ($BACKUP_RUNEVERYNTHDAY*24+12)*60*60 )) ]
then
return 1
fi
function scottysync {
timestamp=$(date +%s)
- scottyinfo Syncing $SYNC_SRC to $REMOTE_HOST:$REMOTE_DIR @$timestamp
+ scottyinfo "Syncing $SYNC_SRC to $REMOTE_HOST:$REMOTE_DIR @$timestamp."
if [ ! -d "$SYNC_SRC" ]; then
- scottyerror Source dir $SYNC_SRC does not exist. Not syncing!
+ scottyerror "Source dir $SYNC_SRC does not exist. Not syncing!"
return 1
fi
if [ $(ls -A "$SYNC_SRC" | wc -l) -eq 0 ]; then
- scottyerror Source dir $SYNC_SRC is empty. Not syncing!
+ scottyerror "Source dir $SYNC_SRC is empty. Not syncing!"
return 1
fi
fi
if (ssh255 $REMOTE_HOST '[ ! -d '$REMOTE_DIR' ]'); then
- scottyinfo Creating destination directory $REMOTE_HOST:$REMOTE_DIR
+ scottyinfo "Creating destination directory $REMOTE_HOST:$REMOTE_DIR."
ssh255 $REMOTE_HOST "mkdir $REMOTE_DIR"
fi
if isIncomplete; then
- scottyerror Continuing old incomplete backup
+ scottyerror "Continuing old incomplete backup."
fi
- scottyinfo Starting rsync
- rsync -e ssh \
- -v -aHAX --numeric-ids --delete --delete-excluded \
- --link-dest=$dir_current \
- $rsync_exclude \
- $SYNC_SRC/ $REMOTE_HOST:$dir_incomplete/
-
+ scottyinfo "Starting rsync."
+ rsync -e ssh --bwlimit=$BWLIMIT \
+ -v -aHAX --numeric-ids --delete --delete-excluded \
+ --link-dest=$dir_current \
+ $rsync_exclude \
+ $SYNC_SRC/ $REMOTE_HOST:$dir_incomplete/
+
if [ $? -eq 0 ]; then
- scottyinfo Timestamping completed backup and linking to current backup
+ scottyinfo "Timestamping completed backup and linking to current backup."
ssh255 $REMOTE_HOST \
- "mv $dir_incomplete $dir_timestamped && rm -f $dir_current && ln -s $(basename $dir_timestamped) $dir_current"
+ "mv $dir_incomplete $dir_timestamped && rm -f $dir_current && \
+ ln -s $(basename $dir_timestamped) $dir_current"
+ else
+ scottyerror "Rsync failed."
fi
while [ $(grepbackups | wc -l) -gt $ARCHIVE_KEEPNBACKUPS ]; do
oldestbackuptstamp=$(echo $oldestbackup | cut -d'-' -f1)
if [ $oldestbackuptstamp -lt $(( $(date +%s) - $ARCHIVE_KEEPNDAYS*60*60*24 )) ]; then
- scottyinfo Removing old backup $oldestbackup
+ scottyinfo "Removing old backup $oldestbackup."
ssh255 $REMOTE_HOST rm -r "$REMOTE_DIR/$oldestbackup"
else
break
}
function deleteLock {
- if ! rmdir /tmp/$(basename $0).lock; then
+ if ! rmdir /var/lock/$(basename $0); then
scottyerror "Could not delete lockfile /tmp/$(basename $0).lock!"
fi
}
-function prepare {
- scottyinfo "Preparing for sync"
-}
-
function cleanup_abort {
- scottyerror "Caught exit signal! Cleaning up..."
+ scottyerror "Caught exit signal! Cleaning up."
cleanup ABORT
if [ $(jobs -p) ]; then
- scottyerror TERMinating remaining child processes...
+ scottyerror "TERMinating remaining child processes."
kill $(jobs -p)
fi
;;
esac
done
-
+
ssh255 $REMOTE_HOST exit
if latestTooOld; then
exit 0
}
-if ! mkdir /tmp/$(basename $0).lock; then
+if ! mkdir /var/lock/$(basename $0); then
scottyerror "Another instance of $(basename $0) is still running!"
exit 1
else